/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationMutableDataCustomizationsDataInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationMutableDataCustomizationsDataInner{}

// CxTemplateInstallationMutableDataCustomizationsDataInner struct for CxTemplateInstallationMutableDataCustomizationsDataInner
type CxTemplateInstallationMutableDataCustomizationsDataInner struct {
	TaskId *string `json:"task_id,omitempty"`
	Content *string `json:"content,omitempty"`
}

// NewCxTemplateInstallationMutableDataCustomizationsDataInner instantiates a new CxTemplateInstallationMutableDataCustomizationsDataInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationMutableDataCustomizationsDataInner() *CxTemplateInstallationMutableDataCustomizationsDataInner {
	this := CxTemplateInstallationMutableDataCustomizationsDataInner{}
	return &this
}

// NewCxTemplateInstallationMutableDataCustomizationsDataInnerWithDefaults instantiates a new CxTemplateInstallationMutableDataCustomizationsDataInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationMutableDataCustomizationsDataInnerWithDefaults() *CxTemplateInstallationMutableDataCustomizationsDataInner {
	this := CxTemplateInstallationMutableDataCustomizationsDataInner{}
	return &this
}

// GetTaskId returns the TaskId field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) GetTaskId() string {
	if o == nil || IsNil(o.TaskId) {
		var ret string
		return ret
	}
	return *o.TaskId
}

// GetTaskIdOk returns a tuple with the TaskId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) GetTaskIdOk() (*string, bool) {
	if o == nil || IsNil(o.TaskId) {
		return nil, false
	}
	return o.TaskId, true
}

// HasTaskId returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) HasTaskId() bool {
	if o != nil && !IsNil(o.TaskId) {
		return true
	}

	return false
}

// SetTaskId gets a reference to the given string and assigns it to the TaskId field.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) SetTaskId(v string) {
	o.TaskId = &v
}

// GetContent returns the Content field value if set, zero value otherwise.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) GetContent() string {
	if o == nil || IsNil(o.Content) {
		var ret string
		return ret
	}
	return *o.Content
}

// GetContentOk returns a tuple with the Content field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) GetContentOk() (*string, bool) {
	if o == nil || IsNil(o.Content) {
		return nil, false
	}
	return o.Content, true
}

// HasContent returns a boolean if a field has been set.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) HasContent() bool {
	if o != nil && !IsNil(o.Content) {
		return true
	}

	return false
}

// SetContent gets a reference to the given string and assigns it to the Content field.
func (o *CxTemplateInstallationMutableDataCustomizationsDataInner) SetContent(v string) {
	o.Content = &v
}

func (o CxTemplateInstallationMutableDataCustomizationsDataInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationMutableDataCustomizationsDataInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TaskId) {
		toSerialize["task_id"] = o.TaskId
	}
	if !IsNil(o.Content) {
		toSerialize["content"] = o.Content
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationMutableDataCustomizationsDataInner struct {
	value *CxTemplateInstallationMutableDataCustomizationsDataInner
	isSet bool
}

func (v NullableCxTemplateInstallationMutableDataCustomizationsDataInner) Get() *CxTemplateInstallationMutableDataCustomizationsDataInner {
	return v.value
}

func (v *NullableCxTemplateInstallationMutableDataCustomizationsDataInner) Set(val *CxTemplateInstallationMutableDataCustomizationsDataInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationMutableDataCustomizationsDataInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationMutableDataCustomizationsDataInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationMutableDataCustomizationsDataInner(val *CxTemplateInstallationMutableDataCustomizationsDataInner) *NullableCxTemplateInstallationMutableDataCustomizationsDataInner {
	return &NullableCxTemplateInstallationMutableDataCustomizationsDataInner{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationMutableDataCustomizationsDataInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationMutableDataCustomizationsDataInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


